
#include "main.h"
#include "PIC18F252_registers.h"
#include "my_lcd.c"

// 
void bcd(ulong);
void bcd_amper(ulong);
void bcd_volt(ulong);
void setup_fun();  // 
// 
//    REF=4096
//    ACS712 ,    2,5 =625
//     185*5+2500 =3425   
//  225 ,  1=45,9=200
//    255 .

// 
//  = 9 ,  = 1      =40
//   =4096/1024=4
//    10   U=4*10*= 

//-----------------------------------------------------------------------------
//     65 s 
#int_timer0
void timer0()
{
   //  , 65*3=195 
   if (input(setup)) 
   { 
      if (ykaz_setup->open) --ykaz_setup->open; 
      ykaz_setup->close=3;    
   } 
   else 
   { 
      if (ykaz_setup->close) --ykaz_setup->close; 
      ykaz_setup->open=3;    
   }
   
   //  , 65*3=195 
   if (input(razrad)) 
   { 
      if (ykaz_razrad->open) --ykaz_razrad->open; 
      ykaz_razrad->close=3;    
   } 
   else 
   { 
      if (ykaz_razrad->close) --ykaz_razrad->close; 
      ykaz_razrad->open=3;    
   }
}
void main()
{
   
   setup_spi(SPI_SS_DISABLED);
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL); //  65 
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
   set_tris_C(0xff);
   //  
   output_bit(yprav,0);
   // 
   lcd_init();
   delay_ms(6);
   // 
   setup_adc_ports(RA0_RA1_ANALOG_RA3_REF);
   setup_adc(ADC_CLOCK_INTERNAL);
   
   // ,   .
   enable_interrupts(int_timer0);   // 
   enable_interrupts(int_timer1);   //  1
   disable_interrupts(global);
   
   //   
   ykaz_volt_amper=&struct_volt_amper;
   ykaz_setup=&struct_setup;
   ykaz_razrad=&struct_razrad;
   ykaz_indic=&struct_indic;
   
   //   setup!=0
   ykaz_setup->close=3;
   //       1
   ykaz_volt_amper->ystav_amper=read_eeprom(1);
   
   //
while(1)
   {   
   //    
   // 
   
   //--------------------------------------------------------------------------
   //
   set_adc_channel(0); //volt
   delay_us(30);
   //  4*10=40 
   ykaz_volt_amper->ismer_volt=read_adc();
   //     ,      1
   //   
   set_adc_channel(1); //amper
   delay_us(30);
   //  4*10=40 
   ykaz_volt_amper->ismer_amper=read_adc();
   ykaz_volt_amper->ismer_amper-=625;  //  
   //,  
   enable_interrupts(global);
   
   //--------------------------------------------------------------------------
   //     
   if(ykaz_volt_amper->ismer_amper>=ykaz_volt_amper->ystav_amper)
   { 
       
         //  
         output_bit(yprav,0);
         //    
         lcd_putc("\fAmper\nMax");
       while(1)
       {
         //  setup  ,  
         if(!ykaz_setup->close)
         {
           setup_fun();  //   
           reset_cpu();
         }
       }
   }
   else
   {
       //  
       output_bit(yprav,1);
       //     
       //ykaz_indic->off=0;
   }
   //-------------------------------------------------------------------------
   //  setup  ,  
   if(!ykaz_setup->close)
      setup_fun();
   //----------------------------------------------------------------------------
   //          
   if(ysred_flag==4)
   {
      //         4
      //         
      ykaz_volt_amper->ismer_volt=symma_volt>>2;   //  4
      ykaz_volt_amper->ismer_amper=symma_amper>>2; //  4
      //--------------------------------------------------------------------------
      // 
      ykaz_volt_amper->ismer_volt=(ykaz_volt_amper->ismer_volt<<2); //*4
      ykaz_volt_amper->ismer_volt*=10;
      bcd_volt(ykaz_volt_amper->ismer_volt);
   
      //  
      lcd_gotoxy(1,1);
      lcd_putc("U=");
      lcd_putc(tusahi+0x30);
      lcd_putc(sotni+0x30);
      lcd_putc(",");
      lcd_putc(dec+0x30);
      lcd_putc("B");
   
      //  
      ykaz_indic->bdc_i_ystav=ykaz_volt_amper->ystav_amper/9; // 200 * 
      ykaz_indic->bdc_i_ystav*=200; //
      bcd_amper(ykaz_indic->bdc_i_ystav);
   
      //   
      lcd_putc("  Iy=");
      lcd_putc(tusahi+0x30);
      lcd_putc(",");
      lcd_putc(sotni+0x30);
      lcd_putc("A");
   
      //  
      ykaz_volt_amper->ismer_amper=ykaz_volt_amper->ismer_amper/9; // 200 * 
      ykaz_volt_amper->ismer_amper*=200; //
      bcd_amper(ykaz_volt_amper->ismer_amper);
   
      //   
      lcd_putc("\nI=");
      lcd_putc(tusahi+0x30);
      lcd_putc(",");
      lcd_putc(sotni+0x30);
      lcd_putc("A");
      
      //     
      ysred_flag=0;
      symma_volt=0;
      symma_amper=0;
   }
   else
   {
      ysred_flag++;
      symma_volt+=ykaz_volt_amper->ismer_volt;
      symma_amper+=ykaz_volt_amper->ismer_amper;
   }
   }
}

void bcd_volt(ulong hislo)
{
   //  ,,  
   tusahi=hislo/10000;
   temp1=tusahi*10000;
   temp2=hislo-temp1;  //       
   sotni=temp2/1000;
   temp1=sotni*1000;
   dec=(temp2-temp1)/100;
   // 
   //temp=(hislo-temp);//  ,    
   //temp2=sotni*10;
   //temp2*=10;
   //raznos=temp-temp2;
   //dec=raznos/10;
   //edin=raznos-dec*10;
}

void bcd(ulong hislo)
{
   //  ,,  
   tusahi=hislo/10000;
   temp1=tusahi*10000;
   sotni=(hislo-temp1)/1000;
   // 
   //temp=(hislo-temp);//  ,    
   //temp2=sotni*10;
   //temp2*=10;
   //raznos=temp-temp2;
   //dec=raznos/10;
   //edin=raznos-dec*10;
}

void bcd_amper(ulong hislo)
{
   //  ,,  
   tusahi=hislo/1000;
   sotni=(hislo-(tusahi*1000))/100;
}

void setup_fun()
{
   //  
   output_bit(yprav,0);
   //    
   while(!ykaz_setup->close);
   //    
   lcd_putc("\fSetup Iy\n");
   while(!ystav_flag)
   {
       lcd_gotoxy(1,2); //  
       lcd_putc("Iy=");
       
       //     setup_fun()
       if(!ykaz_razrad->close)
         ykaz_volt_amper->ystav_amper+=9;
       while(!ykaz_razrad->close);
         //   , 0-225
         if(ykaz_volt_amper->ystav_amper>225)
            ykaz_volt_amper->ystav_amper=0;
       
         //  
         ykaz_indic->bdc_i_ystav=ykaz_volt_amper->ystav_amper/9; // 200 * 
         ykaz_indic->bdc_i_ystav*=200; //
         bcd_amper(ykaz_indic->bdc_i_ystav);
   
         //   
         lcd_putc(tusahi+0x30);
         lcd_putc(",");
         lcd_putc(sotni+0x30);
         lcd_putc("A");
      //?     
      
      //    
      if(!ykaz_setup->close)
         ystav_flag=1;    //    
   }
   //    
   while(!ykaz_setup->close);
   //   
   write_eeprom(1,ykaz_volt_amper->ystav_amper);
   ystav_flag=0;
   lcd_putc("\f");
}
